'pingpong7s.bas
'Mustererzeugung per ser. Schnittstelle
'Dezember 2009
'Hermann Nieder
$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Leds(12) As Word
Dim W As Word
Dim D As Byte
Dim N As Word

Dim X As Byte
Dim Y As Byte
Dim Einsl As Byte
Dim Einsh As Byte
Dim Zweil As Byte
Dim Zweih As Byte
Dim Dreil As Byte
Dim Dreih As Byte
Dim Vierl As Byte
Dim Vierh As Byte
Dim Fuenfl As Byte
Dim Fuenfh As Byte
Dim Sechsl As Byte
Dim Sechsh As Byte
Dim Siebenl As Byte
Dim Siebenh As Byte
Dim Achtl As Byte
Dim Achth As Byte
Dim Neunl As Byte
Dim Neunh As Byte
Dim Zehnl As Byte
Dim Zehnh As Byte
Dim Elfl As Byte
Dim Elfh As Byte
Dim Zwoelfh As Byte
Dim Zwoelfl As Byte
Dim Eins As Word
Dim Zwei As Word
Dim Drei As Word
Dim Vier As Word
Dim Fuenf As Word
Dim Sechs As Word
Dim Sieben As Word
Dim Acht As Word
Dim Neun As Word
Dim Zehn As Word
Dim Elf As Word
Dim Zwoelf As Word

Declare Sub Standby
'Declare Sub Test
Declare Sub Initialisierung

Declare Sub Led1(byval X As Byte , Byval Y As Byte)
Declare Sub Led0(byval X As Byte , Byval Y As Byte)



Initialisierung

Dim Xx As Single
Dim Yy As Single


Do
Inputbin Einsl
Inputbin Einsh
'Printbin 1
Inputbin Zweil
Inputbin Zweih
'Printbin 2
Inputbin Dreil
Inputbin Dreih
'Printbin 3
Inputbin Vierl
Inputbin Vierh
'Printbin 4
Inputbin Fuenfl
Inputbin Fuenfh
'Printbin 5
Inputbin Sechsl
Inputbin Sechsh
'Printbin 6
Inputbin Siebenl
Inputbin Siebenh
'Printbin 7
Inputbin Achtl
Inputbin Achth
'Printbin 8
Inputbin Neunl
Inputbin Neunh
'Printbin 9
Inputbin Zehnl
Inputbin Zehnh
'Printbin 10
Inputbin Elfl
Inputbin Elfh
'Printbin 11
Inputbin Zwoelfl
Inputbin Zwoelfh
'Printbin 255


Eins = Einsh * 256
Leds(1) = Eins + Einsl
Zwei = Zweih * 256
Leds(2) = Zwei + Zweil
Drei = Dreih * 256
Leds(3) = Drei + Dreil
Vier = Vierh * 256
Leds(4) = Vier + Vierl
Fuenf = Fuenfh * 256
Leds(5) = Fuenf + Fuenfl
Sechs = Sechsh * 256
Leds(6) = Sechs + Sechsl
Sieben = Siebenh * 256
Leds(7) = Sieben + Siebenl
Acht = Achth * 256
Leds(8) = Acht + Achtl
Neun = Neunh * 256
Leds(9) = Neun + Neunl
Zehn = Zehnh * 256
Leds(10) = Zehn + Zehnl
Elf = Elfh * 256
Leds(11) = Elf + Elfl
Zwoelf = Zwoelfh * 256
Leds(12) = Zwoelf + Zwoelfl

'Wait 10

'Standby

Loop





Sub Led1(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 1
    Case 2 : Leds(x).8 = 1
    Case 3 : Leds(x).7 = 1
    Case 4 : Leds(x).6 = 1
    Case 5 : Leds(x).5 = 1
    Case 6 : Leds(x).4 = 1
    Case 7 : Leds(x).3 = 1
    Case 8 : Leds(x).2 = 1
    Case 9 : Leds(x).1 = 1
    Case 10 : Leds(x).0 = 1
   End Select
  End If
End Sub

Sub Led0(byval X As Byte , Byval Y As Byte)
 If X < 13 Then
  Select Case Y
    Case 1 : Leds(x).9 = 0
    Case 2 : Leds(x).8 = 0
    Case 3 : Leds(x).7 = 0
    Case 4 : Leds(x).6 = 0
    Case 5 : Leds(x).5 = 0
    Case 6 : Leds(x).4 = 0
    Case 7 : Leds(x).3 = 0
    Case 8 : Leds(x).2 = 0
    Case 9 : Leds(x).1 = 0
    Case 10 : Leds(x).0 = 0
   End Select
  End If
End Sub


'******************  Service-Unterprogramme *********************


Sub Initialisierung
  Config Portc = 15                                         'PORTC als AD-Eingang
  Ddrb = &B11111111                                         'gendert gegenber Vorlage
  Ddrd = &B11111110
  'Config Portd = &B1111111
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2
  Config Adc = Single , Prescaler = 64 , Reference = Off
  Start Adc
  Config Int0 = Low Level                                   'Falling
  On Int0 Int_isr
End Sub


Sub Standby
  Stop Timer2
  Portc = 0
  Portd = 1
  Portb = 0
  Stop Adc
  Ddrd.2 = 0
  Portd.2 = 1
  Enable Int0
  Powerdown
  Ddrd.2 = 1
  Portd.2 = 0
  Start Adc
  Start Timer2
End Sub


Int_isr:
  Disable Int0
Return


'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte


Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15
Portdout = Portdout And 240
Portd = Portdout
Portc = Portcout
Portb = High(leds(vy))
'Waitms 500
Return
End